#include "ColorCoTeXTree.h"
#include <iostream>
#include <Scene.h>
#include <StatusBar.h>

#include "../Primitives/Sphere.h"
#include "../Primitives/ConvPoint.h"
#include "../Primitives/Rbf.h"
#include "../Operators/OperatorUnion.h"

ColorCoTeXTree::ColorCoTeXTree () 
  : CoTeXTreeInterface (new ColorAttribute (DEFAULT_COLOR)) {}

ColorCoTeXTree::ColorCoTeXTree (const ColorCoTeXTree & c) 
  : CoTeXTreeInterface (c) {}

ColorCoTeXTree &ColorCoTeXTree::operator= (const ColorCoTeXTree &) {
  delete getDefaultAttribute ();
  setDefaultAttribute (new ColorAttribute (DEFAULT_COLOR));
  return * this;
}

// **********************
// Interface HyperFunable
// **********************

void ColorCoTeXTree::writeHFString (QTextStream & outStream) {
  outStream << "my_model(x[3],a[1],s[3])" << endl << "{" << endl;
  writeDefArray (outStream);
  outStream << endl;
  writeDefBody (outStream);
  outStream << "my_model = " << getRoot ()->getName () << ";" << endl;
  outStream << "}" << endl;
}


void ColorCoTeXTree::writeDefArray (QTextStream & outStream) {
  getRoot ()->writeDefArray (outStream);
}


void ColorCoTeXTree::writeDefBody (QTextStream & outStream) {
  getRoot ()->writeDefBody (outStream);
}

