#ifndef OPERATORUNION_H
#define OPERATORUNION_H

#include "../Interfaces/OperatorInterface.h"

/// The union operator for CoTeXTrees.
/**
 * The union operator, which give privilege to its first child (left).
 */
class OperatorUnion : public OperatorInterface{
public:
  
  OperatorUnion ();
  virtual ~OperatorUnion () {}
  
  // *******************
  // Interface CoTeXNode
  // *******************
   
  /**
   * Here, this operator try to return a no NULL value from his LeftChild (the last
   * placed in our approche). If it's NULL, the operator return the value form its 
   * RightChild (maybe NULL).
   */
  const AttributeInterface * getAttribute (const Vector3D &position);

  /// Not really useful in constructive texturing, sometimes for vizualisation...
  double eval (const Vector3D& position);

  // **********************
  // Interface HyperFunable
  // **********************
  
  void writeHFString (QTextStream & outStream);
  void writeDefArray (QTextStream & outStream);
  void writeDefBody (QTextStream & outStream);  


  // *****************
  // Interface Savable
  // *****************
 
  void save (QTextStream & stream);
  void load (QTextStream & stream);


};

#endif // OPERATORUNION_H
