#ifndef DOUBLESPINBOX_H
#define DOUBLESPINBOX_H

#include <qspinbox.h>
#include <qvalidator.h>

class DoubleSpinBox : public QSpinBox {

  Q_OBJECT
 
public:
 
  DoubleSpinBox (double minValue, double maxValue, 
		 int decimals = 2, double step = 0.01,
		 double defaultValue = 0.0,
		 QWidget* parent = 0, const char* name = 0);
  ~DoubleSpinBox () {}

  // ********
  // Services
  // ********
  double value () const;
  void setValue (double v);

 protected:
  virtual QString mapValueToText (int value);
  virtual int mapTextToValue (bool * ok = 0);

 private:
  QDoubleValidator* dVal;
  int dec;
  double pow10dec;
};

#endif // DOUBLESPINBOX_H
